AreYouBusy HDU - 3535

转自:https://blog.csdn.net/u013480600/article/details/40652673

Happy New Term! 
As having become a junior, xiaoA recognizes that there is not much time for her to AC problems, because there are some other things for her to do, which makes her nearly mad. 
What's more, her boss tells her that for some sets of duties, she must choose at least one job to do, but for some sets of things, she can only choose at most one to do, which is meaningless to the boss. And for others, she can do of her will. We just define the things that she can choose as "jobs". A job takes time , and gives xiaoA some points of happiness (which means that she is always willing to do the jobs).So can you choose the best sets of them to give her the maximum points of happiness and also to be a good junior(which means that she should follow the boss's advice)? 

Input

There are several test cases, each test case begins with two integers n and T (0<=n,T<=100) , n sets of jobs for you to choose and T minutes for her to do them. Follows are n sets of description, each of which starts with two integers m and s (0<m<=100), there are m jobs in this set , and the set type is s, (0 stands for the sets that should choose at least 1 job to do, 1 for the sets that should choose at most 1 , and 2 for the one you can choose freely).then m pairs of integers ci,gi follows (0<=ci,gi<=100), means the ith job cost ci minutes to finish and gi points of happiness can be gained by finishing it. One job can be done only once.

Output

One line for each test case contains the maximum points of happiness we can choose from all jobs .if she can’t finish what her boss want, just output -1 .

Sample Input

3 3
2 1
2 5
3 8
2 0
1 0
2 1
3 2
4 3
2 1
1 1

3 4
2 1
2 5
3 8
2 0
1 1
2 8
3 2
4 4
2 1
1 1

1 1
1 0
2 1

5 3
2 0
1 0
2 1
2 0
2 2
1 1
2 0
3 2
2 1
2 1
1 5
2 8
3 2
3 8
4 9
5 10

Sample Output

5
13
-1
-1

题意:

       给你n个工作集合,给你T的时间去做它们。给你m和s,说明这个工作集合有m件事可以做,它们是s类的工作集合(s=0,1,2,s=0说明这m件事中最少得做一件,s=1说明这m件事中最多只能做一件,s=2说明这m件事你可以做也可以不做)。再给你ci和gi代表你做这件事要用ci的时间,能获得gi的快乐值。求在T的时间内你能获得的最大快乐值。

分析:

       首先如果存在最优解, 我们可以互换不同工作集合的处理顺序, 依然能得到最优解. 那么我们下面只需要处理每个单独的工作集合即可.

       令dp[i][j]==x表示处理完前i组工作集,所花时间<=j时的快乐值为x。每得到一组工作就进行一次DP,所以dp[i]为第i组的结果。下面对三种情况进行讨论。

       1.    该集合内至少要选1件工作时. 要保证至少选1个第i类工作, 可以从第i-1类的结果dp[i-1]来更新dp[i].也可以用           01背包的思想, 从本类的前一个工作更新后一个工作.

       初始化:dp[i]全为负无穷.(即-INF)

       状态转移方程为:

       dp[i][k]=max{dp[i][k],dp[i-1][k-cost[j]]+val[k],dp[i][k-cost[j]]+val[j] }

       2.    该集合内最多选1件工作时. 只能从上一层的结果dp[i-1]来更新dp[i]了.(想想为什么)

       初始化:dp[i]==dp[i-1].

       状态转移方程为dp[i][k]=max{dp[i][k],dp[i-1][k-cost[j]]+val[k]}.

       3.    该集合内工作可以随便选. 这就是1个普通的01背包问题了.

       初始化:dp[i]==dp[i-1].

       状态转移方程为:

       dp[i][k]=max{dp[i][k],dp[i-1][k-cost[j]]+val[k],dp[i][k-cost[j]]+val[j] }
 

#include<cstdio>
#include<cstring>
#include<algorithm>
using namespace std;
const int inf=0x3f3f3f3f;
int dp[109][109],cost[109],val[109];
int main()
{
	int n,t,m,s;
	while(~scanf("%d%d",&n,&t))
	{
		memset(dp,0,sizeof(dp));
		for(int i=1;i<=n;i++)
		{
			scanf("%d%d",&m,&s);
			for(int j=1;j<=m;j++)
				scanf("%d%d",&cost[j],&val[j]);
			if(s==0)
			{
				for(int j=0;j<=t;j++) dp[i][j]=-inf;
				for(int j=1;j<=m;j++)
					for(int k=t;k>=cost[j];k--)
						dp[i][k]=max(dp[i][k],max(dp[i][k-cost[j]]+val[j],dp[i-1][k-cost[j]]+val[j]));
			}
			if(s==1)
			{
				for(int j=0;j<=t;j++) dp[i][j]=dp[i-1][j];
				for(int j=1;j<=m;j++)
					for(int k=t;k>=cost[j];k--)
						dp[i][k]=max(dp[i][k],dp[i-1][k-cost[j]]+val[j]);
			}
			if(s==2)
			{
				for(int j=0;j<=t;j++) dp[i][j]=dp[i-1][j];
				for(int j=1;j<=m;j++)
					for(int k=t;k>=cost[j];k--)
						dp[i][k]=max(dp[i][k],dp[i][k-cost[j]]+val[j]);
			}
		}
		if(dp[n][t]>0)
			printf("%d\n",dp[n][t]);
		else
			printf("-1\n");
	}
	return 0;
}

猜你喜欢

转载自blog.csdn.net/why932346109/article/details/88542785
hdu
今日推荐